<html>
	<head>
		<meta charset="UTF-8">
		<title>Survey experiment</title>
		<meta http-equiv="Content-Security-Policy-Report-Only"
		      content="default-src 'self' https://code.jquery.com https://cdnjs.cloudflare.com;">
	</head>

	<body>

	<script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/oojs/6.0.0/oojs.min.js" integrity="sha512-fPdkEjaDcqLzzJagvGO4FhpRctvPVZP+EeVtIUI0RUAtlvAFt2wFbol936vb5Ptx1L7hXVP5ELeMWCQ0JRc4XQ==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/oojs-ui/0.42.0/oojs-ui.min.js" integrity="sha512-tsKNHe2limSywdVLNKjPrautXTT8D/nylFXAOcbtMns1FbI2U7WGcTDcUn6sWAdZPy7Y4vleir86EHRTCI/4EQ==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/oojs-ui/0.42.0/oojs-ui-wikimediaui.min.js" integrity="sha512-SwSdE8yq4gDl2+Gyp/UBYU5Ex8eytomSyCkE+tPcOe/qe1Psy1MBLk7MqHgjwuTHzSxEJYBXvHaLJIaHMg+qlQ==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/oojs-ui/0.42.0/oojs-ui-wikimediaui.min.css" integrity="sha512-Gzm0ncQsQThuq5rIXmYRMG91axL3g4zpfCHJkMkng+PAb44QW9sdBE8OxNVIAs/XMD8t5Hhsjw9DA8zousK3OQ==" crossorigin="anonymous" referrerpolicy="no-referrer" />
	<style type="text/css">
		#banner {
			height: 160px;
			background-image: url(https://test.wikipedia.org/static/images/project-logos/testwiki.png);
		}
		#column {
			padding: 5% 20%;
		}
		.demo-simpleWidget {
			display: block;
			position: relative;
			padding: 0.7em 0.9em 0.6em;
			line-height: 1;
		}
		.demo-simpleWidget.oo-ui-iconElement {
			padding-left: 3em;
		}
		.demo-simpleWidget.oo-ui-iconElement .oo-ui-iconElement-icon {
			position: absolute;
			left: 0.9em;
		}
		.oo-ui-buttonWidget {
			margin-top: 2em;
		}
		#debug .oo-ui-labelWidget {
			display: block;
		}
	</style>

	<script lang="javascript">
	$( function () {

	// Base widget
	var DemoSimpleWidget = function DemoSimpleWidget( config ) {
		// Configuration initialization
		config = config || {};
		// Parent constructor
		DemoSimpleWidget.super.call( this, config );
		// Mixin constructors
		OO.ui.mixin.IconElement.call( this, config );
		OO.ui.mixin.LabelElement.call( this, config );
		OO.EventEmitter.call( this );
		var self = this;
		this.$label.on( 'click', function () {
			self.emit( 'labelClick' );
		} );
		// Initialization
		this.$element
			.addClass( 'demo-simpleWidget' )
			.append( this.$icon, this.$label );
	};
	OO.inheritClass( DemoSimpleWidget, OO.ui.Widget );
	OO.mixinClass( DemoSimpleWidget, OO.EventEmitter );
	OO.mixinClass( DemoSimpleWidget, OO.ui.mixin.IconElement );
	OO.mixinClass( DemoSimpleWidget, OO.ui.mixin.LabelElement );

	// Draggable group
	var DemoDraggableGroupWidget = function DemoDraggableGroupWidget( config ) {
		// Configuration initialization
		config = config || {};
		// Parent constructor
		DemoDraggableGroupWidget.super.call( this, config );
		// Mixin constructors
		OO.ui.mixin.DraggableGroupElement.call( this, $.extend( {
			$group: this.$element
		}, config ) );
		this.aggregate( {
			labelClick: 'itemClick',
		} );
		var self = this;
		this.connect( this, {
			itemClick: function ( item ) {
				// FIXME: Clean up indexOf
				var currentIndex = item.elementGroup.getItems().indexOf( item );
				// TODO: make a GroupWidget and wire menus
				var moveToTop = new OO.ui.MenuOptionWidget( {
					label: 'Move to top',
					data: 0,
				} );
				var moveUp = new OO.ui.MenuOptionWidget( {
					label: 'Move up',
					data: currentIndex - 1,
				} );
				// FIXME: Why does moving down require +1 the expected index?
				var moveDown = new OO.ui.MenuOptionWidget( {
					label: 'Move down',
					data: currentIndex + 2,
				} );
				var moveToBottom = new OO.ui.MenuOptionWidget( {
					label: 'Move to bottom',
					data: item.elementGroup.getItems().length,
				} );
				// TODO: nicer menu layout
				var menu = new OO.ui.SelectWidget( {
					items: [
						moveToTop,
						moveUp,
						moveDown,
						moveToBottom,
					],
				} );
				var popup = new OO.ui.PopupWidget( {
					$content: menu.$element,
					autoClose: true,
				} );
				menu.on( 'select', function ( action ) {
					var index = action.getData();
					// FIXME: clean up normally.
					popup.toggle( false );
					delete( menu );
					delete( popup );
					item.$element.find( '.oo-ui-popupWidget' ).remove();
					if ( index !== undefined && index !== currentIndex ) {
						self.moveItem( item, index );
					}
				} );
				item.$element.append( popup.$element );
				popup.toggle( true );
			},
		} );
	};
	OO.inheritClass( DemoDraggableGroupWidget, OO.ui.Widget );
	OO.mixinClass( DemoDraggableGroupWidget, OO.ui.mixin.DraggableGroupElement );

	// Item
	var DemoDraggableHandledItemWidget = function DemoDraggableHandledItemWidget( config ) {
		// Configuration initialization
		config = config || {};
		// Parent constructor
		DemoDraggableHandledItemWidget.super.call( this, config );
		// Mixin constructors
		OO.ui.mixin.DraggableElement.call( this, $.extend( { $handle: this.$icon }, config ) );
	};
	OO.inheritClass( DemoDraggableHandledItemWidget, DemoSimpleWidget );
	OO.mixinClass( DemoDraggableHandledItemWidget, OO.ui.mixin.DraggableElement );

	var randomize = function ( items ) {
		return items.sort( function() {
			return Math.round( Math.random() ) - 0.5;
		} );  
	};

	// Create poll
	var choices = new DemoDraggableGroupWidget( {
		items: randomize( [
			new DemoDraggableHandledItemWidget( {
				data: 'maps',
				icon: 'draggable',
				label: 'Marvelous Maps'
			} ),
			new DemoDraggableHandledItemWidget( {
				data: 'geoinfo',
				icon: 'draggable',
				label: 'Gyrating Geoinfo'
			} ),
			new DemoDraggableHandledItemWidget( {
				data: 'templates',
				icon: 'draggable',
				label: 'Twisted Templates'
			} ),
		] ),
	} );

	// Layout
	var layout = new OO.ui.FieldLayout( choices, {
		align: 'top',
		label: 'Please rearrange choices with your highest preference at the top.',
	} );

	var text = new OO.ui.FieldLayout(
		new OO.ui.MultilineTextInputWidget( {} ), {
			align: 'top',
			label: 'Optional comment',
		}
	);

	var button = new OO.ui.ButtonWidget( {
		label: 'Publish ranking',
		flags: [
			'primary',
			'progressive'
		]
	} );

	var $resultsDisplay = $( '<div id="debug">' );

	button.on( 'click', function () {
		// TODO: method to return order data
		var results = choices.$group.children().map( function () {
			// TODO: Also get the machine data
			return $( this ).text();
		} ).get();
		$resultsDisplay.prepend(
			( new OO.ui.LabelWidget( {
				label: new OO.ui.HtmlSnippet(
					"<p>Your ranking:<br />" + results.join("<br />") )
			} ) ).$element
		);
	} );

	$( '#poll' ).append(
		layout.$element,
		text.$element,
		button.$element,
		$resultsDisplay
	);

	} );
	</script>
	<noscript>
		TODO: noscript form here
	</noscript>

	<div id="banner"></div>
	<div id="column">
		<div id="poll"></div>
	</div>
	</body>
</html>
